package com.dsic.gj_erp.bean.jhgk;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.dsic.gj_erp.bean.jhgk.excel.ZrcAndPlb;
import com.dsic.gj_erp.exception.ServiceException;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 * 
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="DmZrcjh对象", description="")
public class DmZrcjh implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "船号")
    @TableField("DC_CH")
    private String dcCh;

    @ApiModelProperty(value = "区域")
    private String qy;

    @ApiModelProperty(value = "总段号")
    private String zdh;

    @ApiModelProperty(value = "预组段")
    private String yzd;

    @ApiModelProperty(value = "分段号")
    @TableField("DC_FD")
    private String dcFd;

    @ApiModelProperty(value = "重量")
    @TableField("ZL")
    private Double zl;

    @ApiModelProperty(value = "批量号")
    @TableField("DC_PL")
    private String dcPl;

    @ApiModelProperty(value = "大组开始")
    private String kssjDz;

    @ApiModelProperty(value = "钢加大组结束")
    private String gjjsDz;

    @ApiModelProperty(value = "小组结束")
    private String jssjXz;

    @ApiModelProperty(value = "小组周期")
    private String xzzq;

    @ApiModelProperty(value = "小组开始")
    private String kssjXz;

    @ApiModelProperty(value = "线表重量")
    private Double xbzl;

    @ApiModelProperty(value = "批量表（钢加大组结束）")
    private String gjjsDzPl;

    @ApiModelProperty(value = "时间差（L-P）")
    private String sjcLp;

    @ApiModelProperty(value = "钢加小组结束")
    private String gjjsXz;

    @ApiModelProperty(value = "批量表（钢加小组结束）")
    private String gjjsXzPl;

    @ApiModelProperty(value = "时间差（R-S）")
    private String sjcRs;

    @ExcelIgnore
    @ApiModelProperty(value = "钢加开始")
    private String gjks;

    @ApiModelProperty(value = "批量表（钢加开始）")
    private String gjksPl;

    @ApiModelProperty(value = "时间差（U-V）")
    private String sjcUv;

    @ApiModelProperty(value = "套料图下发")
    private String xfqTlt;

    @ApiModelProperty(value = "套料图接收")
    private String jsqTlt;

    @ApiModelProperty(value = "板材领取表下发")
    private String xfqLqb;

    @ApiModelProperty(value = "板材领取表接收")
    private String jsqLqb;

    @ApiModelProperty(value = "零件配套表下发")
    private String xfqPtb;

    @ApiModelProperty(value = "零件配套表接收")
    private String jsqPtb;

    @ApiModelProperty(value = "订货清单号")
    private String dhqd;

    @ApiModelProperty(value = "订货清单下发")
    private String xfqDhqd;

    @ApiModelProperty(value = "实际订货日期")
    private String sjdhq;

    @ApiModelProperty(value = "板材计划到齐")
    private String bcdq;

    @ApiModelProperty(value = "状态； 0编辑1提交2审核；默认为0；")
//    @ExcelField(value = "状态")
    private String zt;

    @TableId(value = "xh", type = IdType.ASSIGN_UUID)
//    @ExcelField(value = "序号")
    private String xh;

    @ApiModelProperty(value = "编制人")
    private String bzr;

    @ApiModelProperty(value = "编制日期 yyyy/MM/dd")
    private String bzrq;

    private int dataOrder;

    public static DmZrcjh createByExcel(String dcCh, String fd, ZrcAndPlb item){
        DmZrcjh dmZrcjh = new DmZrcjh();
        dmZrcjh.setDcCh(dcCh);
        dmZrcjh.setDcPl(item.getDcPl());
        dmZrcjh.setDcFd(fd);
        try {
            dmZrcjh.setZl(Double.valueOf(item.getTon()));
        }catch (Exception e){
            throw new ServiceException(10001,"吨位不是数字");
        }
        dmZrcjh.setGjks(item.getGjks());
        dmZrcjh.setKssjDz(item.getGjks());
        dmZrcjh.setKssjXz(item.getGjks());
        dmZrcjh.setGjjsDz(item.getGjjs());
        dmZrcjh.setGjjsXz(item.getGjjs());
        dmZrcjh.setJssjXz(item.getGjjs());
        dmZrcjh.setXfqTlt(item.getTlt());
        dmZrcjh.setXfqLqb(item.getBclqb());
        dmZrcjh.setXfqDhqd(item.getDhqd());
        dmZrcjh.setBcdq(item.getGldq());
        dmZrcjh.setZt("0");
        dmZrcjh.setDataOrder(item.getDataOrder());
        return dmZrcjh;
    }
}
