package com.dsic.gj_erp.controller.zyjh;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.zyjh.Ycldw;
import com.dsic.gj_erp.service.zyjh.YcldwService;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@RestController
@RequestMapping("ycldw")
@AllArgsConstructor
public class YcldwController {

    private final YcldwService service;

    @PostMapping("list")
    public ResultBean<?> list(@RequestBody Ycldw ycldw) {
        return new ResultBean<>(
            service.list(Wrappers.<Ycldw>lambdaQuery()
                .eq(Ycldw::getType,Ycldw.getTypeForYcl())
                .eq(StrUtil.isNotEmpty(ycldw.getKw()),Ycldw::getKw,ycldw.getKw())
        ));
    }

    @PostMapping("submit")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> edit(@RequestBody Map<String,List<Ycldw>> map) {
        if (map.get("add")!=null){
            map.get("add").forEach(item->{
                item.setTypeForYcl();
                service.save(item);
            });
        }

        if (map.get("edit")!=null){
            service.updateBatchById(map.get("edit"));
        }

        if (map.get("remove")!=null){
            List<Integer> remove = map.get("remove").stream().map(Ycldw::getId).collect(Collectors.toList());
            service.removeByIds(remove);
        }

        return new ResultBean<>();
    }
}
